| Bsoft 1.9 Bernard's software package

- Main Page
- Namespaces
- Classes
- Files

- File List
- File Members

Classes | Macros | Typedefs | Enumerations | Functions
fftw.h File Reference
`#include <stdlib.h>`
`#include <stdio.h>`

Go to the source code of this file.

## Classes
struct | fftw_complex
struct | fftw_codelet_desc
struct | fftw_twiddle_struct
struct | fftw_rader_data_struct
struct | fftw_plan_node_struct
struct | fftw_plan_struct
struct | fftwnd_data

## Macros
#define | FFTW_ENABLE_FLOAT 1
#define | FFTW_VERSION "2.1.5"
#define | FFTW_H
#define | c_re(c) ((c).re)
#define | c_im(c) ((c).im)
#define | FFTW_1_0_COMPATIBILITY 0
#define | DL_IMPORT(type) type
#define | FFTW_ESTIMATE (0)
#define | FFTW_MEASURE (1)
#define | FFTW_OUT_OF_PLACE (0)
#define | FFTW_IN_PLACE (8)
#define | FFTW_USE_WISDOM (16)
#define | FFTW_THREADSAFE
#define | FFTWND_FORCE_BUFFERED
#define | FFTW_NO_VECTOR_RECURSE
#define | FFTW_HAS_PLAN_SPECIFIC
#define | FFTW_HAS_WISDOM
#define | FFTW_HAS_FPRINT_PLAN
#define | FFTWND_HAS_PRINT_PLAN

## Typedefs
typedef float | fftw_real
typedef fftw_complex | FFTW_COMPLEX
typedef fftw_real | FFTW_REAL
typedef void( | fftw_notw_codelet) (const fftw_complex *, fftw_complex *, int, int)
typedef void( | fftw_twiddle_codelet) (fftw_complex *, const fftw_complex *, int, int, int)
typedef void( | fftw_generic_codelet) (fftw_complex *, const fftw_complex *, int, int, int, int)
typedef void( | fftw_real2hc_codelet) (const fftw_real *, fftw_real *, fftw_real *, int, int, int)
typedef void( | fftw_hc2real_codelet) (const fftw_real *, const fftw_real *, fftw_real *, int, int, int)
typedef void( | fftw_hc2hc_codelet) (fftw_real *, const fftw_complex *, int, int, int)
typedef void( | fftw_rgeneric_codelet) (fftw_real *, const fftw_complex *, int, int, int, int)
typedef struct fftw_twiddle_struct | fftw_twiddle
typedef struct fftw_rader_data_struct | fftw_rader_data
typedef void( | fftw_rader_codelet) (fftw_complex *, const fftw_complex *, int, int, int, fftw_rader_data *)
typedef struct fftw_plan_node_struct | fftw_plan_node
typedef struct fftw_plan_struct * | fftw_plan
typedef void *(* | fftw_malloc_type_function) (size_t n)
typedef void(* | fftw_free_type_function) (void *p)
typedef void(* | fftw_die_type_function) (const char *errString)
typedef fftwnd_data * | fftwnd_plan

## Enumerations
enum | fftw_direction { FFTW_FORWARD = -1, FFTW_BACKWARD = 1 }
enum | fftw_status { FFTW_SUCCESS = 0, FFTW_FAILURE = -1 }
enum | fftw_node_type { FFTW_NOTW, FFTW_TWIDDLE, FFTW_GENERIC, FFTW_RADER, FFTW_REAL2HC, FFTW_HC2REAL, FFTW_HC2HC, FFTW_RGENERIC }
enum | fftw_recurse_kind { FFTW_NORMAL_RECURSE = 0, FFTW_VECTOR_RECURSE = 1 }

## Functions
| DL_IMPORT (const char *) fftw_version
fftw_plan | fftw_create_plan_specific (int n, fftw_direction dir, int flags, fftw_complex *in, int istride, fftw_complex *out, int ostride)
fftw_plan | fftw_create_plan (int n, fftw_direction dir, int flags)
void | fftw_print_plan (fftw_plan plan)
void | fftw_destroy_plan (fftw_plan plan)
void | fftw (fftw_plan plan, int howmany, fftw_complex *in, int istride, int idist, fftw_complex *out, int ostride, int odist)
void | fftw_one (fftw_plan plan, fftw_complex *in, fftw_complex *out)
void | fftw_die (const char *s)
void * | fftw_malloc (size_t n)
void | fftw_free (void *p)
void | fftw_check_memory_leaks (void)
void | fftw_print_max_memory_usage (void)
| DL_IMPORT (fftw_malloc_type_function) fftw_malloc_hook
| DL_IMPORT (fftw_free_type_function) fftw_free_hook
| DL_IMPORT (fftw_die_type_function) fftw_die_hook
size_t | fftw_sizeof_fftw_real (void)
void | fftw_forget_wisdom (void)
void | fftw_export_wisdom (void(*emitter)(char c, void *), void *data)
fftw_status | fftw_import_wisdom (int(*g)(void *), void *data)
void | fftw_export_wisdom_to_file (FILE *output_file)
fftw_status | fftw_import_wisdom_from_file (FILE *input_file)
char * | fftw_export_wisdom_to_string (void)
fftw_status | fftw_import_wisdom_from_string (const char *input_string)
void | fftw_fprint_plan (FILE *f, fftw_plan plan)
fftwnd_plan | fftw2d_create_plan (int nx, int ny, fftw_direction dir, int flags)
fftwnd_plan | fftw3d_create_plan (int nx, int ny, int nz, fftw_direction dir, int flags)
fftwnd_plan | fftwnd_create_plan (int rank, const int *n, fftw_direction dir, int flags)
fftwnd_plan | fftw2d_create_plan_specific (int nx, int ny, fftw_direction dir, int flags, fftw_complex *in, int istride, fftw_complex *out, int ostride)
fftwnd_plan | fftw3d_create_plan_specific (int nx, int ny, int nz, fftw_direction dir, int flags, fftw_complex *in, int istride, fftw_complex *out, int ostride)
fftwnd_plan | fftwnd_create_plan_specific (int rank, const int *n, fftw_direction dir, int flags, fftw_complex *in, int istride, fftw_complex *out, int ostride)
void | fftwnd_destroy_plan (fftwnd_plan plan)
void | fftwnd_fprint_plan (FILE *f, fftwnd_plan p)
void | fftwnd_print_plan (fftwnd_plan p)
void | fftwnd (fftwnd_plan plan, int howmany, fftw_complex *in, int istride, int idist, fftw_complex *out, int ostride, int odist)
void | fftwnd_one (fftwnd_plan p, fftw_complex *in, fftw_complex *out)

## Macro Definition Documentation

#define c_im | ( |  | c | ) | ((c).im)

Definition at line 61 of file fftw.h.

#define c_re | ( |  | c | ) | ((c).re)

Definition at line 60 of file fftw.h.

#define DL_IMPORT | ( |  | type | ) | type

Definition at line 152 of file fftw.h.

#define FFTW_1_0_COMPATIBILITY 0

Definition at line 72 of file fftw.h.

#define FFTW_ENABLE_FLOAT 1

Definition at line 32 of file fftw.h.

#define FFTW_ESTIMATE (0)

Definition at line 288 of file fftw.h.

#define FFTW_H

Definition at line 38 of file fftw.h.

#define FFTW_HAS_FPRINT_PLAN

Definition at line 349 of file fftw.h.

#define FFTW_HAS_PLAN_SPECIFIC

Definition at line 309 of file fftw.h.

#define FFTW_HAS_WISDOM

Definition at line 336 of file fftw.h.

#define FFTW_IN_PLACE (8)

Definition at line 292 of file fftw.h.

#define FFTW_MEASURE (1)

Definition at line 289 of file fftw.h.

#define FFTW_NO_VECTOR_RECURSE

Value:
(512) /* internal flag, prevents use
of vector recursion */

Definition at line 302 of file fftw.h.

#define FFTW_OUT_OF_PLACE (0)

Definition at line 291 of file fftw.h.

#define FFTW_THREADSAFE

Value:
(128) /* guarantee plan is read-only so that the
same plan can be used in parallel by
multiple threads */

Definition at line 295 of file fftw.h.

#define FFTW_USE_WISDOM (16)

Definition at line 293 of file fftw.h.

#define FFTW_VERSION "2.1.5"

Definition at line 35 of file fftw.h.

#define FFTWND_FORCE_BUFFERED

Value:
(256) /* internal flag, forces buffering
in fftwnd transforms */

Definition at line 299 of file fftw.h.

#define FFTWND_HAS_PRINT_PLAN

Definition at line 415 of file fftw.h.

## Typedef Documentation

typedef fftw_complex FFTW_COMPLEX

Definition at line 68 of file fftw.h.

typedef void(* fftw_die_type_function) (const char *errString)

Definition at line 324 of file fftw.h.

typedef void(* fftw_free_type_function) (void *p)

Definition at line 323 of file fftw.h.

typedef void( fftw_generic_codelet) (fftw_complex *, const fftw_complex *, int, int, int, int)

Definition at line 98 of file fftw.h.

typedef void( fftw_hc2hc_codelet) (fftw_real *, const fftw_complex *, int, int, int)

Definition at line 107 of file fftw.h.

typedef void( fftw_hc2real_codelet) (const fftw_real *, const fftw_real *, fftw_real *, int, int, int)

Definition at line 104 of file fftw.h.

typedef void*(* fftw_malloc_type_function) (size_t n)

Definition at line 322 of file fftw.h.

typedef void( fftw_notw_codelet) (const fftw_complex *, fftw_complex *, int, int)

Definition at line 93 of file fftw.h.

typedef struct fftw_plan_struct* fftw_plan

Definition at line 285 of file fftw.h.

typedef struct fftw_plan_node_struct fftw_plan_node

typedef void( fftw_rader_codelet) (fftw_complex *, const fftw_complex *, int, int, int, fftw_rader_data *)

Definition at line 188 of file fftw.h.

typedef struct fftw_rader_data_struct fftw_rader_data

typedef float fftw_real

Definition at line 49 of file fftw.h.

typedef fftw_real FFTW_REAL

Definition at line 69 of file fftw.h.

typedef void( fftw_real2hc_codelet) (const fftw_real *, fftw_real *, fftw_real *, int, int, int)

Definition at line 101 of file fftw.h.

typedef void( fftw_rgeneric_codelet) (fftw_real *, const fftw_complex *, int, int, int, int)

Definition at line 110 of file fftw.h.

typedef struct fftw_twiddle_struct fftw_twiddle

typedef void( fftw_twiddle_codelet) (fftw_complex *, const fftw_complex *, int, int, int)

Definition at line 95 of file fftw.h.

typedef fftwnd_data* fftwnd_plan

Definition at line 383 of file fftw.h.

## Enumeration Type Documentation

enum fftw_direction

Enumerator
FFTW_FORWARD |
FFTW_BACKWARD |

Definition at line 63 of file fftw.h.

enum fftw_node_type

Enumerator
FFTW_NOTW |
FFTW_TWIDDLE |
FFTW_GENERIC |
FFTW_RADER |
FFTW_REAL2HC |
FFTW_HC2REAL |
FFTW_HC2HC |
FFTW_RGENERIC |

Definition at line 120 of file fftw.h.

enum fftw_recurse_kind

Enumerator
FFTW_NORMAL_RECURSE |
FFTW_VECTOR_RECURSE |

Definition at line 266 of file fftw.h.

enum fftw_status

Enumerator
FFTW_SUCCESS |
FFTW_FAILURE |

Definition at line 85 of file fftw.h.

## Function Documentation

DL_IMPORT | ( | const char * |  | ) |

DL_IMPORT | ( | fftw_malloc_type_function |  | ) |

DL_IMPORT | ( | fftw_free_type_function |  | ) |

DL_IMPORT | ( | fftw_die_type_function |  | ) |

void fftw | ( | fftw_plan | plan,
|  | int | howmany,
|  | fftw_complex * | in,
|  | int | istride,
|  | int | idist,
|  | fftw_complex * | out,
|  | int | ostride,
|  | int | odist
| ) |  |

Definition at line 402 of file executor.c.

fftwnd_plan fftw2d_create_plan | ( | int | nx,
|  | int | ny,
|  | fftw_direction | dir,
|  | int | flags
| ) |  |

Definition at line 451 of file fftwnd.c.

fftwnd_plan fftw2d_create_plan_specific | ( | int | nx,
|  | int | ny,
|  | fftw_direction | dir,
|  | int | flags,
|  | fftw_complex * | in,
|  | int | istride,
|  | fftw_complex * | out,
|  | int | ostride
| ) |  |

Definition at line 414 of file fftwnd.c.

fftwnd_plan fftw3d_create_plan | ( | int | nx,
|  | int | ny,
|  | int | nz,
|  | fftw_direction | dir,
|  | int | flags
| ) |  |

Definition at line 457 of file fftwnd.c.

fftwnd_plan fftw3d_create_plan_specific | ( | int | nx,
|  | int | ny,
|  | int | nz,
|  | fftw_direction | dir,
|  | int | flags,
|  | fftw_complex * | in,
|  | int | istride,
|  | fftw_complex * | out,
|  | int | ostride
| ) |  |

Definition at line 428 of file fftwnd.c.

void fftw_check_memory_leaks | ( | void |  | ) |

Definition at line 203 of file malloc.c.

fftw_plan fftw_create_plan | ( | int | n,
|  | fftw_direction | dir,
|  | int | flags
| ) |  |

Definition at line 450 of file planner.c.

fftw_plan fftw_create_plan_specific | ( | int | n,
|  | fftw_direction | dir,
|  | int | flags,
|  | fftw_complex * | in,
|  | int | istride,
|  | fftw_complex * | out,
|  | int | ostride
| ) |  |

Definition at line 421 of file planner.c.

void fftw_destroy_plan | ( | fftw_plan | plan | ) |

Definition at line 472 of file planner.c.

void fftw_die | ( | const char * | s | ) |

Definition at line 192 of file malloc.c.

void fftw_export_wisdom | ( | void(*)(char c, void *) | emitter,
|  | void * | data
| ) |  |

Definition at line 158 of file wisdom.c.

void fftw_export_wisdom_to_file | ( | FILE * | output_file | ) |

Definition at line 32 of file wisdomio.c.

char* fftw_export_wisdom_to_string | ( | void |  | ) |

Definition at line 67 of file wisdomio.c.

void fftw_forget_wisdom | ( | void |  | ) |

Definition at line 125 of file wisdom.c.

void fftw_fprint_plan | ( | FILE * | f,
|  | fftw_plan | plan
| ) |  |

Definition at line 536 of file putils.c.

void fftw_free | ( | void * | p | ) |

Definition at line 178 of file malloc.c.

fftw_status fftw_import_wisdom | ( | int(*)(void *) | g,
|  | void * | data
| ) |  |

Definition at line 262 of file wisdom.c.

fftw_status fftw_import_wisdom_from_file | ( | FILE * | input_file | ) |

Definition at line 43 of file wisdomio.c.

fftw_status fftw_import_wisdom_from_string | ( | const char * | input_string | ) |

Definition at line 97 of file wisdomio.c.

void* fftw_malloc | ( | size_t | n | ) |

Definition at line 160 of file malloc.c.

void fftw_one | ( | fftw_plan | plan,
|  | fftw_complex * | in,
|  | fftw_complex * | out
| ) |  |

Definition at line 455 of file executor.c.

void fftw_print_max_memory_usage | ( | void |  | ) |

Definition at line 233 of file malloc.c.

void fftw_print_plan | ( | fftw_plan | plan | ) |

Definition at line 547 of file putils.c.

size_t fftw_sizeof_fftw_real | ( | void |  | ) |

Definition at line 552 of file putils.c.

void fftwnd | ( | fftwnd_plan | plan,
|  | int | howmany,
|  | fftw_complex * | in,
|  | int | istride,
|  | int | idist,
|  | fftw_complex * | out,
|  | int | ostride,
|  | int | odist
| ) |  |

Definition at line 746 of file fftwnd.c.

fftwnd_plan fftwnd_create_plan | ( | int | rank,
|  | const int * | n,
|  | fftw_direction | dir,
|  | int | flags
| ) |  |

Definition at line 445 of file fftwnd.c.

fftwnd_plan fftwnd_create_plan_specific | ( | int | rank,
|  | const int * | n,
|  | fftw_direction | dir,
|  | int | flags,
|  | fftw_complex * | in,
|  | int | istride,
|  | fftw_complex * | out,
|  | int | ostride
| ) |  |

Definition at line 307 of file fftwnd.c.

void fftwnd_destroy_plan | ( | fftwnd_plan | plan | ) |

Definition at line 481 of file fftwnd.c.

void fftwnd_fprint_plan | ( | FILE * | f,
|  | fftwnd_plan | p
| ) |  |

Definition at line 504 of file fftwnd.c.

void fftwnd_one | ( | fftwnd_plan | p,
|  | fftw_complex * | in,
|  | fftw_complex * | out
| ) |  |

Definition at line 803 of file fftwnd.c.

void fftwnd_print_plan | ( | fftwnd_plan | p | ) |

Definition at line 539 of file fftwnd.c.